﻿@{
    ViewBag.Title = "webupload";
    Layout = "~/Views/Shared/_PopViewLayout.cshtml";
}
@section HeadCss{
    @if (false)
    {
        <link href="/Content/public/bootstrap3/bootstrap.css" rel="stylesheet" type="text/css" />
    }
    <link href="../../Scripts/Plugins/webuploader/webuploader.css" rel="stylesheet" type="text/css" />
    <style type="text/css">
        .filedelete
        {
            height: 90px;
        }
    </style>
}
@section Scripts{
    @if (false)
    {
        <script src="../../Scripts/Public/jquery-1.11.1.js" type="text/javascript"></script>
        <script src="../../Scripts/Public/bootstrap3/bootstrap.js" type="text/javascript"></script>
        <script src="../../Scripts/Public/sa/jquery.sa.ajax.js" type="text/javascript"></script>
    }
    <script src="../../Scripts/Plugins/webuploader/webuploader.js" type="text/javascript"></script>
    <script type="text/jscript">
        var $ = jQuery;
        var $list = $('#thelist');
        var $btn = $('#ctlBtn');
        var state = 'pending';
        var responseList = [];//存放服务端返回结果
        var successCount = 0;//记录文件上传成功个数
        var errorCount = 0;//记录失败个数
        var exts='@ViewBag.extensions';
        var nums=@ViewBag.numLimit;
        var uploader = WebUploader.create({

            // swf文件路径
            swf: '/Scripts/Plugins/webuploader/Uploader.swf',

            // 文件接收服务端。
            server: '/File/UploadFile',

            // 选择文件的按钮。可选。
            // 内部根据当前运行是创建，可能是input元素，也可能是flash.
            pick: '#picker',

            // 不压缩image, 默认如果是jpeg，文件上传前会压缩一把再上传！
            resize: false
            , runtimeOrder: 'flash'

            , accept: {
                //title: 'Image',
                extensions: exts
              //, mimeTypes: 'image,rar'
            }
            , fileNumLimit: nums           

        });

        // 当有文件被添加进队列的时候
        uploader.on('fileQueued', function (file) {
            var fileQueuedHtml = '<div id="' + file.id + '" class="list-group-item list-group-item-info row">';
            fileQueuedHtml += '<div class="col-lg-10 col-md-10 col-sm-9 col-xs-12 fileinfo" >';
            fileQueuedHtml += '<span class="info h4">' + file.name + '</span>';
            fileQueuedHtml += '<h6 class="text-muted">' + WebUploader.formatSize(file.size) + '</h6>'; 
            fileQueuedHtml += '<span class="state h5">@Resource.ForUpload</span>';
            fileQueuedHtml += '</div>';
            fileQueuedHtml += '<div class="col-lg-2 col-md-2 col-sm-3 col-xs-12 ">';

            fileQueuedHtml += '<button class ="btn btn-danger btn-block  btn-lg filedelete" >@Resource.Remove</button>';

            fileQueuedHtml += '</div>';
            fileQueuedHtml += '</div>'
            $list.append(fileQueuedHtml);
        });

        $(document).ready(function () {
            $(document).on("click", ".filedelete", function () {
                var fileid = $(this).parent().parent().attr("id");
                var file = uploader.getFile(fileid);
                uploader.removeFile(file);
            });
            //获取pick按钮设置占整行（调试得知）
            $("#uploader").find(".webuploader-pick").addClass("btn-lg btn-block");

        });


        // 当有文件被移除进队列的时候
        uploader.on('fileDequeued', function (file) {
            $("#" + file.id).remove();
        });

        // 文件上传过程中创建进度条实时显示。
        uploader.on('uploadProgress', function (file, percentage) {
            var $li = $('#' + file.id).find(".fileinfo");
            $percent = $li.find('.progress .progress-bar');

            // 避免重复创建
            if (!$percent.length) {
                $percent = $('<div class="progress">' + '<div class="progress-bar  progress-bar-success" role="progressbar"   style="width: 100%">0%' + '</div>' + '</div>').appendTo($li).find('.progress-bar');
            }

            $li.find('.state').text('@Resource.Uploading');

            $percent.css('width', Math.round(percentage * 100) + '%');
            $percent.text(Math.round(percentage * 100) + '%');

        });
        uploader.on('uploadSuccess', function (file, response) {
            if (response.result == "Success") {
                $('#' + file.id).find('.state').text('@Resource.Uploaded');
                $('#' + file.id).find('.state').addClass("text-success");
                $('#' + file.id).find('.filedelete').hide();

                var responseFile = response.data.fileList[0];
                responseFile.FileSize = WebUploader.formatSize(file.size);
                responseFile.FileType = file.type;
                responseList.push(responseFile);
                successCount++;
            }
            else {
                errorCount++;
            }
        });

        uploader.on('uploadError', function (file) {
            $('#' + file.id).find('.state').text('@Resource.UploadError');
        });

        uploader.on('uploadComplete', function (file) {
            $('#' + file.id).find('.progress').fadeOut();
        });


        uploader.on('all', function (type) {
            if (type === 'startUpload') {
                state = 'uploading';
            } else if (type === 'stopUpload') {
                state = 'paused';
            } else if (type === 'uploadFinished') {
                state = 'done';
            }

            if (state === 'uploading') {
                $btn.html('<span class="glyphicon glyphicon-pause"></span>@Resource.SuspendUpload');
            } else {
                $btn.html(' <span class="glyphicon glyphicon-open"></span>@Resource.StartUpload');
            }
        });

        $btn.bind('click', function () {
            if (state === 'uploading') {
                uploader.stop(true);
            } else {
                uploader.upload();
            }
        });
        
        //上传结束，回调GetUploadFiles方法，返回上传列表
        uploader.on('uploadFinished', function () {
            $.sa.alert("@Resource.FileUploadSuccess".format(successCount,errorCount), { title: "@Resource.PromptMessage", isModal: true, position: "center", timeout: 0, fnClose: function () { $(".close", parent.document).click(); parent.GetUploadFiles(responseList); } });
        });

        uploader.on('error', function (handler) {
            if (handler == 'Q_TYPE_DENIED') {
                $.sa.error("@Resource.FileTypeError");
            }
            if (handler == 'Q_EXCEED_NUM_LIMIT') {
                $.sa.error("@Resource.BeyondFileCount");                
            }
        })
 

    </script>
}
<div id="uploader" class="wu-example">
    <!--用来存放文件信息-->
    <div id="thelist" class="list-group container-fluid">
    </div>
    <div id="picker" class="">
        <span class="glyphicon glyphicon-file"></span>@Resource.SelectFile
    </div>
    <button id="ctlBtn" class="btn  btn-lg btn-success btn-block">
        <span class="glyphicon glyphicon-open"></span>@Resource.StartUpload
    </button>
</div>
